]> diplodocus.org Git - nmh/blobdiff - test/common.sh.in
Added context_find_prefix().
[nmh] / test / common.sh.in
index aa1e8455b433230b4fbde42e14ead072d0b69e95..74e5f63256d52a6f18a691738e79d9776e564aa3 100644 (file)
@@ -32,6 +32,10 @@ unset LANG LC_ALL LC_CTYPE
 MHTMPDIR=$MH_TEST_DIR/Mail
 export MHTMPDIR
 
+#### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
+#### the test suite from cleaning up the results of a test run, if you need
+#### to do manual debugging on a test.
+
 output_md5()
 {
   #### Output just the checksum.  If the filename needs to appear on
@@ -131,12 +135,18 @@ check_for_hard_links () {
   set +e
 
   printf '' > "${MH_TEST_DIR}/$$-1"
+  xdir_links_supported=0
   if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
     hard_links_supported=1
+    mkdir "${MH_TEST_DIR}/xlinkdir"
+    if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/xlinkdir/$$-2" 2>/dev/null; then
+       xdir_links_supported=1
+    fi
   else
     hard_links_supported=0
   fi
   rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
+  rm -rf "${MH_TEST_DIR}/xlinkdir"
 
   set -e
 }
@@ -160,7 +170,7 @@ prepare_space() {
 #### Optional arguments:
 ####   'keep first' -- first file is removed unless this is present.
 ####   'ignore space' -- spacing differences will not be considered
-####        signficant, emulating GNU diff -w.  It is assumed that the
+####        significant, emulating GNU diff -w.  It is assumed that the
 ####        first file has already been run through prepare_space.
 ####   ':' <test name> -- will print '<test name>' in the failure message,
 ####        to make it easier to tell which of multiple tests has failed.
@@ -245,8 +255,51 @@ run_test() {
   fi
 }
 
+#### Function invoked by trap on exit.
+cleanup() {
+    #### Save exit status to use as status for this program.
+    status=$?
+
+    #### Clean up test mail space.
+    #### cd to $MH_TEST_DIR before trying to remove its Mail
+    #### subdirectory.  rm on Solaris won't remove it if it's in the
+    #### path of the current working directory.
+    test -z "$MH_TEST_NOCLEANUP" && (cd $MH_TEST_DIR; rm -rf "$MH_TEST_DIR"/Mail)
+
+    #### Report test name if set, which indicates failure.
+    #### Relies on set -e to invoke the trap which calls
+    #### this function on failure.
+    #### To use:
+    #### 1) Set test name before running the test, use start_test().
+    #### 2) Unset upon successful completion, use finish_test().
+    if test -n "$nmh_tests_testname"; then
+        echo $nmh_tests_testname failed
+    fi
+
+    #### Exit with non-zero status if failure.  Failure is defined as either
+    #### non-empty nmh_tests_testname or non-zero exit status on entry to the
+    #### function.
+    if test -n "$nmh_tests_testname"  -o  $status -ne 0; then
+        test $status -ne 0  &&  exit $status  ||  exit 1
+        test $status -ne 0  &&  exit 0  ||  exit 0
+    fi
+}
+
+#### Function to set the test name, and whatever the future brings.
+start_test() {
+    nmh_tests_testname="$1"
+}
+
+#### Corresponding function to indicate that the test has finished.  It need
+#### not be called after each test, just the last one in a file.
+finish_test() {
+    unset nmh_tests_testname
+}
+
 setup_test ()
 {
+  set -e
+
   MH="${MH_TEST_DIR}/Mail/.mh_profile"
   MHMTSCONF="${MH_INST_DIR}${nmhetcdir}/mts.conf"
   MH_LIBEXEC_DIR="${MH_INST_DIR}${nmhlibexecdir}"
@@ -279,8 +332,9 @@ setup_test ()
   PATH="${MH_INST_DIR}${bindir}:${PATH}"
   export PATH
 
-  # clean old test data
-  trap "cd $MH_TEST_DIR; rm -rf '$MH_TEST_DIR/Mail'" 0
+  # clean old test data on exit
+  trap cleanup 0
+
   # setup test data
   mkdir -p "$MH_TEST_DIR/Mail" || exit 1
   cat > "$MH" <<EOF || exit 1